
CoCoA-5 - Slug #750

C5 GUI: very slow when printing many short lines

27 Jul 2015 16:50 - John Abbott

Status: Closed Start date: 27 Jul 2015

Priority: Normal Due date:  

Assignee: John Abbott % Done: 100%

Category: GUI Estimated time: 1.23 hour

Target version: CoCoA-5.4.2 Spent time: 1.15 hour

Description

The GUI takes ages to print out the following:

indent(1..100000);

 

No idea why :-(  "top" says my computer is 88% idle... odd!

Related issues:

Related to CoCoA-5 - Bug #1093: GUI: bugs and slugs In Progress 23 Jul 2017

Related to CoCoA-5 - Design #1698: indent: return a string? Closed 27 Sep 2022

History

#1 - 23 Jul 2017 16:15 - John Abbott

- Related to Bug #1093: GUI: bugs and slugs added

#2 - 18 Aug 2022 15:27 - John Abbott

2022-08-18: JAA confirms that this slug is still present.

It suffices to test indent(1..1000)

top reported that gnome-shell was using about 30% CPU.

I wonder if output is too often flushed?

#3 - 27 Sep 2022 22:27 - John Abbott

- Status changed from New to In Progress

- % Done changed from 0 to 10

I created a single string containing many new lines: this printed instantly.

jaa := "jaa\n";

S := ConcatStrings([jaa | i in 1..1000]);

println S; --> instant in GUI

 

This does make me wonder whether "println" causes a costly flush.

A workaround could be to make indent return a string rather than calling println many times.

The code would stay almost the same, except it would print onto an OpenOString.
#4 - 27 Sep 2022 22:33 - John Abbott

- Related to Design #1698: indent: return a string? added

#5 - 07 Oct 2022 11:06 - John Abbott

- Status changed from In Progress to Closed

- Assignee set to John Abbott

- Target version changed from CoCoA-5.?.? to CoCoA-5.4.2

- % Done changed from 10 to 100

- Estimated time set to 1.23 h

We do not really have the resources to investigate and fix this.

While the "slow newline problem" is not ideal, it is also not so

very serious.

We close this issue because: severity low, difficulty/time great.
